/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.c
 * Copyright (C) 2019
 *
 * 8008135 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * 8008135 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/****  Debugging ***************************************************************
*******************************************************************************/

#ifndef SRC_INCLUDE__HEADERS_UTILS_H_
#define SRC_INCLUDE_HEADERS_UTILS_H_
#define DEBUG_ENABLED 1

/****  Debugging ***************************************************************
*******************************************************************************/

/* variadic macro for debug messages */
#define debug(str, ...) 					\
if (DEBUG_ENABLED) {			 			\
	pr_info("[ 8008135 ] [ %s ] " str "\n", 		\
		__func__, ##__VA_ARGS__); 			\
}

#define alert(str, ...) 					\
if (DEBUG_ENABLED) { 						\
	pr_warn("[ 8008135 ] [ %s ] " str "\n", 		\
		__func__, ##__VA_ARGS__); 			\
}

#endif /* SRC_INCLUDE_HEADERS_UTILS_H_ */
